# Enum Class StackWalker.Option

java.lang.Object
java.lang.Enum<StackWalker.Option>
java.lang.StackWalker.Option

All Implemented Interfaces:
  `Serializable, Comparable<StackWalker.Option>, Constable`

Enclosing class:
  `StackWalker`

public static enum StackWalker.Option extends Enum<StackWalker.Option>
Stack walker option to configure the stack frame information obtained by a `StackWalker`.

Since:
  9

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`
  Modifier and Type
  Class
  Description
  `static final class`
  `Enum.EnumDesc<E extends Enum<E>>`
  A nominal descriptor for an `enum` constant.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `DROP_METHOD_INFO`
  Drops the method information from `StackFrame`s walked by this `StackWalker`.
  `RETAIN_CLASS_REFERENCE`
  Retains `Class` object in `StackFrame`s walked by this `StackWalker`.
  `SHOW_HIDDEN_FRAMES`
  Shows all hidden frames.
  `SHOW_REFLECT_FRAMES`
  Shows all reflection frames.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static StackWalker.Option`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static StackWalker.Option[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`
  Modifier and Type
  Method
  Description
  `protected final Object`
  `clone()`
  Throws CloneNotSupportedException.
  `final int`
  `compareTo(StackWalker.Option o)`
  Compares this enum with the specified object for order.
  `final Optional<Enum.EnumDesc<StackWalker.Option>>`
  `describeConstable()`
  Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
  `final boolean`
  `equals(Object other)`
  Returns true if the specified object is equal to this enum constant.
  `protected final void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization has been deprecated for removal.
  `final Class<StackWalker.Option>`
  `getDeclaringClass()`
  Returns the Class object corresponding to this enum constant's enum type.
  `final int`
  `hashCode()`
  Returns a hash code for this enum constant.
  `final String`
  `name()`
  Returns the name of this enum constant, exactly as declared in its enum declaration.
  `final int`
  `ordinal()`
  Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
  `String`
  `toString()`
  Returns the name of this enum constant, as contained in the declaration.
  `static <T extends Enum<T>>
  T`
  `valueOf(Class<T> enumClass, String name)`
  Returns the enum constant of the specified enum class with the specified name.

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Enum Constant Details

  - ### RETAIN_CLASS_REFERENCE

    public static final StackWalker.Option RETAIN_CLASS_REFERENCE
    Retains `Class` object in `StackFrame`s walked by this `StackWalker`.

    A `StackWalker` configured with this option will support `StackWalker.getCallerClass()` and `StackFrame.getDeclaringClass()`.

  - ### DROP_METHOD_INFO

    public static final StackWalker.Option DROP_METHOD_INFO
    Drops the method information from `StackFrame`s walked by this `StackWalker`.

    A `StackWalker` configured with this option will drop the method name, the method type, the line number, the bytecode index, the source file name and native method or not.

    Since:
      22

  - ### SHOW_REFLECT_FRAMES

    public static final StackWalker.Option SHOW_REFLECT_FRAMES
    Shows all reflection frames.

    By default, reflection frames are hidden. A `StackWalker` configured with this `SHOW_REFLECT_FRAMES` option will show all reflection frames that include `Method.invoke(Object, Object...)` and `Constructor.newInstance(Object...)` and their reflection implementation classes.

    The `SHOW_HIDDEN_FRAMES` option can also be used to show all reflection frames and it will also show other hidden frames that are implementation-specific.

    API Note:
      This option includes the stack frames representing the invocation of `Method` and `Constructor`. Any utility methods that are equivalent to calling `Method.invoke` or `Constructor.newInstance` such as `Class.newInstance` are not filtered or controlled by any stack walking option.

  - ### SHOW_HIDDEN_FRAMES

    public static final StackWalker.Option SHOW_HIDDEN_FRAMES
    Shows all hidden frames.

    A Java Virtual Machine implementation may hide implementation specific frames in addition to reflection frames. A `StackWalker` with this `SHOW_HIDDEN_FRAMES` option will show all hidden frames (including reflection frames).

- ## Method Details

  - ### values

    public static StackWalker.Option[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static StackWalker.Option valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null